SystemOrganization addCategory: #'SourceCity-Importer'!

Object subclass: #AbstractSourceCityImporterStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Importer'!

!AbstractSourceCityImporterStrategy commentStamp: '<historical>' prior: 0!
I'm the object which is needed to SourceCityImporter!

!AbstractSourceCityImporterStrategy methodsFor: 'strategy' stamp: 'blo 7/5/2012 11:34'!
buildingGap
	self subclassResponsibility! !

!AbstractSourceCityImporterStrategy methodsFor: 'strategy' stamp: 'blo 7/4/2012 14:32'!
buildingNameGenerator
	self subclassResponsibility! !

!AbstractSourceCityImporterStrategy methodsFor: 'strategy' stamp: 'blo 7/4/2012 14:30'!
buildingsSelector
	self subclassResponsibility! !

!AbstractSourceCityImporterStrategy methodsFor: 'strategy' stamp: 'blo 7/5/2012 11:35'!
cityWidth
	self subclassResponsibility! !

!AbstractSourceCityImporterStrategy methodsFor: 'strategy' stamp: 'blo 7/5/2012 11:34'!
districtGap
	self subclassResponsibility! !

!AbstractSourceCityImporterStrategy methodsFor: 'strategy' stamp: 'blo 7/4/2012 14:34'!
districtNameGenerator
	self subclassResponsibility! !

!AbstractSourceCityImporterStrategy methodsFor: 'strategy' stamp: 'blo 7/5/2012 11:35'!
districtWidth
	self subclassResponsibility! !

!AbstractSourceCityImporterStrategy methodsFor: 'strategy' stamp: 'blo 7/4/2012 14:30'!
districtsSelector
	self subclassResponsibility! !

!AbstractSourceCityImporterStrategy methodsFor: 'strategy' stamp: 'blo 7/5/2012 11:21'!
normalizedBuildingDimension
	self subclassResponsibility! !

!AbstractSourceCityImporterStrategy methodsFor: 'strategy' stamp: 'blo 7/4/2012 10:58'!
normalizedColor
	self subclassResponsibility! !

AbstractSourceCityImporterStrategy subclass: #SourceCityImporterASTCoreRpackageStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Importer'!

!SourceCityImporterASTCoreRpackageStrategy methodsFor: 'strategy' stamp: 'blo 7/5/2012 11:35'!
buildingGap
	^ 2! !

!SourceCityImporterASTCoreRpackageStrategy methodsFor: 'strategy' stamp: 'blo 7/4/2012 14:36'!
buildingNameGenerator
	^ [:anObject | anObject]! !

!SourceCityImporterASTCoreRpackageStrategy methodsFor: 'strategy' stamp: 'blo 7/4/2012 14:31'!
buildingsSelector 
	^ [:anObject | anObject classes]! !

!SourceCityImporterASTCoreRpackageStrategy methodsFor: 'tools' stamp: 'blo 7/4/2012 11:08'!
calculMix: color1 at: color1Perc and: color2 at: color2Perc
	
	^Color r: ((color1 red * color1Perc) + (color2 red * color2Perc))
				g: ((color1 green * color1Perc) + (color2 green * color2Perc))
				b: ((color1 blue * color1Perc) + (color2 blue * color2Perc))! !

!SourceCityImporterASTCoreRpackageStrategy methodsFor: 'tools' stamp: 'blo 7/4/2012 11:04'!
calculRatio: anObject
	^ (self normalizedHeight value: anObject) / (self maxLevel)! !

!SourceCityImporterASTCoreRpackageStrategy methodsFor: 'strategy' stamp: 'blo 7/7/2012 22:31'!
cityWidth
	^ [:aCity | ((aCity districts inject: 0 into: [:sum :aDistrict | sum + (aDistrict dimension x + (2 * self districtGap)) ]) /(1+ aCity districts size sqrt)  asFloat roundedUp)]! !

!SourceCityImporterASTCoreRpackageStrategy methodsFor: 'strategy' stamp: 'blo 7/5/2012 11:35'!
districtGap
	^ 2! !

!SourceCityImporterASTCoreRpackageStrategy methodsFor: 'strategy' stamp: 'blo 7/5/2012 12:57'!
districtNameGenerator
	^ [:anObject | anObject asString]! !

!SourceCityImporterASTCoreRpackageStrategy methodsFor: 'strategy' stamp: 'blo 7/7/2012 22:15'!
districtWidth
	^ [:aDistrict | ((aDistrict buildings inject: 0 into: [:max :aBuilding | max max: aBuilding dimension x]) + (2 * self buildingGap)) 
		max: (((aDistrict buildings inject: 0 into: [:sum :aBuilding | sum + (aBuilding dimension x + (2 * self buildingGap)) ]) /(1+aDistrict buildings size sqrt))  asFloat roundedUp)]
		
		
		! !

!SourceCityImporterASTCoreRpackageStrategy methodsFor: 'strategy' stamp: 'blo 7/4/2012 14:31'!
districtsSelector 
	^ [:anObject | anObject]! !

!SourceCityImporterASTCoreRpackageStrategy methodsFor: 'tools' stamp: 'blo 7/5/2012 11:12'!
heightNormalizer
	^ [:height | 0.5 max: (2 * (height sqrt))]! !

!SourceCityImporterASTCoreRpackageStrategy methodsFor: 'tools' stamp: 'blo 7/4/2012 10:41'!
heightSelector
	^ [:anObject | (anObject selectors size)]! !

!SourceCityImporterASTCoreRpackageStrategy methodsFor: 'tools' stamp: 'blo 7/3/2012 11:32'!
lowColor
	^Color green! !

!SourceCityImporterASTCoreRpackageStrategy methodsFor: 'tools' stamp: 'blo 7/3/2012 11:32'!
maxColor
	^Color red! !

!SourceCityImporterASTCoreRpackageStrategy methodsFor: 'tools' stamp: 'blo 7/4/2012 11:10'!
maxLevel
	^ self heightNormalizer value: 50! !

!SourceCityImporterASTCoreRpackageStrategy methodsFor: 'strategy' stamp: 'blo 7/5/2012 11:23'!
normalizedBuildingDimension
	^ [:anObject | Point3D x: (self normalizedXWidth value: anObject)
		y: (self normalizedHeight value: anObject)
		z: (self normalizedZWidth value: anObject) ]! !

!SourceCityImporterASTCoreRpackageStrategy methodsFor: 'strategy' stamp: 'blo 7/4/2012 11:12'!
normalizedColor
	|ratio|
	^ [:anObject | ratio := self calculRatio: anObject. 
		(ratio > 1) 
			ifTrue: [self maxColor] 
			ifFalse:[self calculMix: self lowColor at: (1-ratio) and: self maxColor at: (ratio)]].! !

!SourceCityImporterASTCoreRpackageStrategy methodsFor: 'tools' stamp: 'blo 7/5/2012 16:15'!
normalizedHeight
	^ [:anObject |  1 max: ((self heightNormalizer) value: (self heightSelector value: anObject)) ]! !

!SourceCityImporterASTCoreRpackageStrategy methodsFor: 'tools' stamp: 'blo 7/5/2012 16:15'!
normalizedXWidth
	^ [:anObject | 1 max: ((self widthNormalizer) value: (self widthSelector value: anObject)) ]! !

!SourceCityImporterASTCoreRpackageStrategy methodsFor: 'tools' stamp: 'blo 7/5/2012 16:15'!
normalizedZWidth
	^ [:anObject | 1 max: ((self widthNormalizer) value: (self widthSelector value: anObject)) ]! !

!SourceCityImporterASTCoreRpackageStrategy methodsFor: 'tools' stamp: 'blo 7/5/2012 11:11'!
widthNormalizer
	^ [:width | 0.5 max: (2 * (width sqrt))]! !

!SourceCityImporterASTCoreRpackageStrategy methodsFor: 'tools' stamp: 'blo 7/4/2012 10:55'!
widthSelector
	^ [:anObject | (anObject allInstVarNames size)].! !

AbstractSourceCityImporterStrategy subclass: #SourceCityImporterDefaultStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Importer'!

!SourceCityImporterDefaultStrategy commentStamp: '<historical>' prior: 0!
I'm the default use of AbstractSourceCityImporter!

!SourceCityImporterDefaultStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 7/1/2012 00:22'!
buildingsSelector 
	#classes! !

!SourceCityImporterDefaultStrategy methodsFor: 'accessing' stamp: 'blo 7/4/2012 10:26'!
heightNormalizer
	^ [:height | 2 * (height sqrt)]! !

!SourceCityImporterDefaultStrategy methodsFor: 'accessing' stamp: 'blo 7/4/2012 10:33'!
heightSelector
	^ [:anObject | (anObject selectors size)]! !

!SourceCityImporterDefaultStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 7/1/2012 14:31'!
lowColor
	^Color green! !

!SourceCityImporterDefaultStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 7/1/2012 14:31'!
maxColor
	^Color red! !

!SourceCityImporterDefaultStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 7/1/2012 14:31'!
maxLevel
	^50! !

!SourceCityImporterDefaultStrategy methodsFor: 'accessing' stamp: 'blo 7/4/2012 10:39'!
normalizedHeight
	^ [:anObject | (anObject perform: self heightSelector) perform: (self heightNormalizer)]! !

!SourceCityImporterDefaultStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 7/1/2012 14:33'!
widthNormalizer
	^#sqrt! !

!SourceCityImporterDefaultStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 7/1/2012 14:32'!
widthSelector
	^#allInstVarNames! !

Object subclass: #SourceCityImporter
	instanceVariableNames: 'city districts buildings sourceCityMapping'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Importer'!

!SourceCityImporter commentStamp: '<historical>' prior: 0!
I'm responsible for populating a city from a model (usually a ring model)!

!SourceCityImporter class methodsFor: 'default-model' stamp: 'blo 7/4/2012 14:42'!
title: aCityName strategy: aSourceCityImporterStrategy import: anObject
	^ self new 
		import: anObject strategy: aSourceCityImporterStrategy named: aCityName! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/30/2012 23:53'!
buildings
	^ buildings! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/30/2012 23:53'!
buildings: anObject
	buildings := anObject! !

!SourceCityImporter methodsFor: 'import' stamp: 'blo 7/5/2012 14:12'!
categorizeCity: aCity
	"ensure there is not duplicated element and provide an id for each one"
	aCity districts do: [:aDistrict | (self ensureDistrictAbsent: aDistrict) 
		ifTrue: [districts add: aDistrict. self categorizeDistrict: aDistrict]]! !

!SourceCityImporter methodsFor: 'import' stamp: 'blo 7/5/2012 14:13'!
categorizeDistrict: aDistrict
	"ensure there is not duplicated element and provide an id for each one"
	aDistrict buildings do: [:aBuilding | (self ensureBuildingAbsent: aBuilding) 
		ifTrue: [buildings add: aBuilding]]! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/30/2012 23:53'!
city
	^ city! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/30/2012 23:53'!
city: anObject
	city := anObject! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/30/2012 23:53'!
districts
	^ districts! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/30/2012 23:53'!
districts: anObject
	districts := anObject! !

!SourceCityImporter methodsFor: 'import' stamp: 'blo 7/9/2012 10:53'!
ensureBuildingAbsent: aBuilding
	^ (buildings contains: [:b | b = aBuilding]) not		! !

!SourceCityImporter methodsFor: 'import' stamp: 'blo 7/4/2012 15:32'!
ensureDistrictAbsent: aDistrict
	^ (districts contains: [:d | d = aDistrict]) not		! !

!SourceCityImporter methodsFor: 'import' stamp: 'blo 7/5/2012 12:34'!
import: anObject strategy: aStrategy named: aName
	self city: (SourceCityFactory createCity: anObject named: aName strategy: aStrategy).
	self categorizeCity: city.
	SourceCityMapping defineCityMapping: city strategy: aStrategy.! !

!SourceCityImporter methodsFor: 'initialize-release' stamp: 'blo 7/5/2012 14:14'!
initialize
	super initialize.
	districts := OrderedCollection new.
	buildings := OrderedCollection new.! !

Object subclass: #SourceCityMapping
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Importer'!

!SourceCityMapping class methodsFor: 'as yet unclassified' stamp: 'blo 7/9/2012 10:48'!
defineCityMapping: aCity strategy: aStrategy
	| x z zMax cityWidth districtGap |
		
	aCity districts do: [:aDistrict | self defineDistrictMapping: aDistrict strategy: aStrategy].
		
	zMax := 0.
	districtGap := aStrategy districtGap.
	cityWidth := aStrategy cityWidth value: aCity.
	x := districtGap. z := districtGap..
	aCity districts do: [:district |			
		((x + districtGap + district dimension x)  > cityWidth)
		ifTrue: [x := districtGap. z := districtGap + zMax +z. zMax := 0.].
		district position: (Point3D x:x y:2 z:z).
		x := districtGap + x + district dimension x .
		zMax := zMax max: district dimension z.
	].
	aCity dimension: (Point3D x: cityWidth y: 2 z: (z + zMax + districtGap)).
	aCity position: (Point3D x: 0 y: 0 z: 0).
	! !

!SourceCityMapping class methodsFor: 'as yet unclassified' stamp: 'blo 7/8/2012 10:56'!
defineDistrictMapping: aDistrict strategy: aStrategy
	| x z zMax districtWidth buildingGap |
	buildingGap := aStrategy buildingGap.
	districtWidth := aStrategy districtWidth value: aDistrict.
	x := 0. z := aStrategy buildingGap.
	zMax := 0.
	aDistrict buildings do: [:building |			
		((x + buildingGap + building dimension x)  > districtWidth)
		ifTrue: [x := buildingGap. z := buildingGap + zMax +z. zMax := 0.].
		building position: (Point3D x:x y: 2 z:z).
		x := building dimension x + buildingGap + x.
		zMax := zMax max: building dimension z.
	].
	aDistrict dimension: (Point3D x: districtWidth y: 2 z: (z + zMax + buildingGap))! !
